#!/gpfs/apps/MN5/GPP/PYTHON/3.12.1/INTEL/bin/python3

import sys
import numpy as np
from read_utils import *
import matplotlib.pyplot as plt

def main():
    #Argument parsing:
    if len(sys.argv) < 2:
        print(f"Usage: {sys.argv[0]} <root rundir>")
        print(f"Usage: {sys.argv[0]} dir1 [dir2] [dir3]")
        sys.exit(1)

    # Search for rundirs:
    rundirs = []
    for root_rundir_arg in sys.argv[1:]:
        rundirs.extend(find_rundirs_folders(root_rundir_arg))
    rundirs = sorted(rundirs)

    plot_one_by_one = False

    # Get data:
    results = {}
    for rundir in rundirs:
        ts_completed = get_timesteps(rundir)
        print(f"{rundir} => {ts_completed} ts")

        ts_time_dict = get_timestep_timings(rundir, ts_completed)
        steps = list(ts_time_dict.keys())
        times = list(ts_time_dict.values())

        #print(f"max: {np.max(times)} min: {np.min(times)}  avg: {np.average(times)}")

        if plot_one_by_one:
            plt.figure()
            #plt.plot(steps, times, marker='o', linestyle='-')
            plt.bar(steps, times, color='blue')
            plt.title('Time per step')
            plt.xlabel('Timestep')
            plt.ylabel('Time(s)')
            plt.grid(True)
            plt.tight_layout()
            plt.show()

        results[rundir] = ts_time_dict


        plt.plot(steps, times, label=str(rundir), linestyle='', marker='s')

    #plt.legend()
    plt.tight_layout()
    plt.show()
    plt.savefig(input("enter plot name: "))


if __name__ == "__main__":
    main()
